dnl $Id: config.m4 328375 2012-11-16 08:13:40Z rahulpriyadarshi $
dnl config.m4 for extension ibm_db2

dnl Comments in this file start with the string 'dnl'.
dnl Remove where necessary. This file will not work
dnl without editing.

dnl If your extension references something external, use with:

PHP_ARG_WITH(IBM_DB2, for IBM_DB2 support,
[  --with-IBM_DB2=[DIR]      Include IBM DB2 Univeral Database and Cloudscape support.
                          DIR is the location of the DB2 application development 
                          headers and libraries. Set the PHP_IBM_DB2_LIB
                          environment variable to set the specific location of
                          the DB2 libraries])

dnl PHP_ARG_ENABLE(IBM_DB2, whether to enable IBM_DB2 support,
dnl Make sure that the comment is aligned:
dnl [  --enable-IBM_DB2           Enable IBM_DB2 support])
if test "$PHP_IBM_DB2" != "no"; then
  dnl # checking php 32/64 bit php
  AC_MSG_CHECKING(PHP)
  if test `php -r 'echo PHP_INT_SIZE;'` = 8; then
    machine_bits=64
    libDir=lib64
    AC_MSG_RESULT(Detected 64-bit PHP)
  else
    machine_bits=32
    libDir=lib32
    AC_MSG_RESULT(Detected 32-bit PHP)
  fi
  AC_MSG_CHECKING(IBM_DB_HOME location)
  if test $IBM_DB_HOME ; then
    SEARCH_PATH=$IBM_DB_HOME
    AC_MSG_RESULT($IBM_DB_HOME)
  else
    AC_MSG_RESULT(not found)
  fi
  dnl # Looking for DB2 CLI path
  AC_MSG_CHECKING(DB2 CLI Path)
  if test $IBM_DB_HOME || test "$PHP_IBM_DB2" != "yes" || test $PHP_IBM_DB2_LIB || test $DB2PATH || test $DB2DIR; then
    AC_MSG_RESULT(found)
  else
    AC_MSG_RESULT(not found)
    ptf="";
    if test `php -r 'echo PHP_OS;'` = Linux; then
        ptf="Linux"
        currPath=$PWD
        if test $machine_bits = 64; then
            cliFileName=linuxx64_odbc_cli.tar.gz
        else
            cliFileName=linuxia32_odbc_cli.tar.gz
        fi
    else
        AC_MSG_ERROR([Auto installation of DS driver is not enabled for this platform, Please install and set IBM_DB_HOME to your DB2/IBM_Data_Server_Driver installation directory and retry ibm_db2 module install])
    fi
    extPath=`php-config --extension-dir`
    cliPath=$extPath/clidriver
    url="http://public.dhe.ibm.com/ibmdl/export/pub/software/data/db2/drivers/odbc_cli/$cliFileName"
    license_agreement="****************************************
    You are downloading a package which includes the PECL module for IBM DB2/Informix.  The module is licensed under the Apache License 2.0. The package also includes IBM ODBC and CLI Driver from IBM, which is automatically downloaded as the PECL module is installed on your system/device. The license agreement to the IBM ODBC and CLI Driver is available in $cliPath.   Check for additional dependencies, which may come with their own license agreement(s). Your use of the components of the package and dependencies constitutes your acceptance of their respective license agreements. If you do not accept the terms of any license agreement(s), then delete the relevant component(s) from your device.
****************************************"

    AC_MSG_RESULT(Downloading DB2 ODBC CLI Driver from $url)
    AC_CHECK_FILE(downInstCli.php, fPath=downInstCli.php, fPath=./../../ibm_db2/downInstCli.php)
    AC_CHECK_FILE($fPath, ,)
    msg=`php $fPath $url $cliFileName $extPath $ptf`
    AC_CHECK_FILE($cliFileName, , AC_MSG_ERROR(Error occurred in download))
    SEARCH_PATH=$cliPath
  fi
  
  dnl # --with-IBM_DB2 -> check with-path  	 
  SEARCH_PATH="$PHP_IBM_DB2_LIB $SEARCH_PATH $PHP_IBM_DB2 $DB2PATH $DB2DIR"

  AC_MSG_CHECKING(Looking for DB2 CLI libraries)
  for i in $SEARCH_PATH ; do
    AC_MSG_CHECKING([     in $i])
    if test -r $i/libdb2.so || test -r $i/libdb2.a || test -r $i/libdb400.a || test -r $i/libdb2.dylib ; then
      LIB_DIR="$i/"
      AC_MSG_RESULT(found)
      break
    else
      AC_MSG_RESULT()
    fi
    AC_MSG_CHECKING([     in $i/$libDir])
    if test -r $i/$libDir/libdb2.so || test -r $i/$libDir/libdb2.a || test -r $i/$libDir/libdb400.a || test -r $i/$libDir/libdb2.dylib ; then
      LIB_DIR="$i/$libDir/"
      AC_MSG_RESULT(found)
      break
    else
      AC_MSG_RESULT()
    fi
    AC_MSG_CHECKING([     in $i/lib])
    if test -r $i/lib/libdb2.so || test -r $i/lib/libdb2.a || test -r $i/lib/libdb400.a || test -r $i/lib/libdb2.dylib ; then
      LIB_DIR="$i/lib/"
      AC_MSG_RESULT(found)
      break
    else
      AC_MSG_RESULT()
    fi
  done

  if test -z "$LIB_DIR"; then
    AC_MSG_RESULT([not found])
    if test $IBM_DB_HOME ; then
      AC_MSG_ERROR([Cannot find DB2 CLI libraries. Check if you have set the IBM_DB_HOME environment variable's value correctly])
    else
       AC_MSG_ERROR([Environment variable IBM_DB_HOME is not set. Set it to your DB2/IBM_Data_Server_Driver installation directory and retry ibm_db2 module install])
    fi
  fi

  AC_MSG_CHECKING([for DB2 CLI include files in default path])
  for i in $SEARCH_PATH ; do
    AC_MSG_CHECKING([in $i])
    dnl this is for V8.1 and previous
    if test -r "$i/include/sqlcli1.h" ; then
      IBM_DB2_DIR=$i
      AC_MSG_RESULT(found in $i)
      break
    fi
  done

  if test -z "$IBM_DB2_DIR"; then
    AC_MSG_RESULT([not found])
    AC_MSG_ERROR([Please reinstall the DB2 CLI distribution])
  fi

  dnl # --with-IBM_DB2 -> add include path
  PHP_ADD_INCLUDE($IBM_DB2_DIR/include)

  dnl # --with-IBM_DB2 -> check for lib and symbol presence
  if test -r $LIB_DIR/libdb400.a ; then
    LIBNAME=db400
    PHP_NEW_EXTENSION(ibm_db2, ibm_db2.c, $ext_shared,,-DPASE)
  else
    LIBNAME=db2
    PHP_NEW_EXTENSION(ibm_db2, ibm_db2.c, $ext_shared)
  fi
  LIBSYMBOL=SQLConnect

dnl #  PHP_CHECK_LIBRARY($LIBNAME,$LIBSYMBOL,
dnl #  [
    PHP_ADD_LIBRARY_WITH_PATH($LIBNAME, $LIB_DIR , IBM_DB2_SHARED_LIBADD)
    AC_DEFINE(HAVE_DB2CLILIB,1,[ ])
dnl #  ],[
dnl #    AC_MSG_ERROR([wrong DB2 CLI lib version or lib not found])
dnl #  ],[
dnl #    -L$IBM_DB2_DIR/lib -lm -ldl
dnl #  ])

  PHP_SUBST(IBM_DB2_SHARED_LIBADD)
  AC_MSG_NOTICE($license_agreement)
fi
